﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectExcavator.DrawingObjects;

namespace ProjectExcavator.MovementStrategy
{
    /// <summary>
    /// Реализация интерфейса IDrawningObject для работы с объектом DrawningCar (паттерн Adapter)
    /// </summary>
    public class DrawingObjectExcavator : IMoveableObject
    {
        private readonly DrawingExcavator? _drawingExcavator = null;
        public DrawingObjectExcavator(DrawingExcavator drawingExcavator)
        {
            _drawingExcavator = drawingExcavator;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawingExcavator == null || _drawingExcavator.EntityExcavator ==
                null)
                {
                    return null;
                }
                return new ObjectParameters(_drawingExcavator.GetPosX,
                _drawingExcavator.GetPosY, _drawingExcavator.GetWidth, _drawingExcavator.GetHeight);
            }
        }
        public int GetStep => (int)(_drawingExcavator?.EntityExcavator?.Step ?? 0);
        public bool CheckCanMove(DirectionType direction) =>
        _drawingExcavator?.CanMove(direction) ?? false;
        public void MoveObject(DirectionType direction) =>
        _drawingExcavator?.MoveTransport(direction);
    }
}
