﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator.Entities
{
    /// <summary>
    /// Класс-сущность "Экскаватор Ковш"
    /// </summary>
    public class EntityExcavatorKovsh : EntityExcavator
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        /// Ковш
        /// </summary>
        public bool Kovsh { get; private set; }
        /// <summary>
        /// Катки гусеничные
        /// </summary>
        public bool Katki { get; private set; }

        /// <summary>
        /// Инициализация полей объекта-класса экскаватора с ковшом
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="kovsh">Признак наличия ковша</param>
        /// <param name="katki">Признак наличия катков</param>
        public EntityExcavatorKovsh(int speed, double weight, Color bodyColor, Color additionalColor, bool kovsh, bool katki) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Kovsh = kovsh;
            Katki = katki;
        }
    }
}
