using ProjectExcavator.DrawingObjects;
using ProjectExcavator.MovementStrategy;

namespace ProjectExcavator
{
    public partial class FormExcavator : Form
    {

        private DrawingExcavator? _drawingExcavator;
        /// <summary>
        ///  
        /// </summary>
        private AbstractStrategy? _abstractStrategy;
        public FormExcavator()
        {
            InitializeComponent();        
        }

        private void Draw()
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxExcavator.Width, pictureBoxExcavator.Height);
            Graphics g = Graphics.FromImage(bmp);
            _drawingExcavator.DrawTransport(g);
            pictureBoxExcavator.Image = bmp;
        }
        private void buttonCreateExKovsh_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingExcavator = new DrawingExcavatorKovsh(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxExcavator.Width, pictureBoxExcavator.Height);
            _drawingExcavator.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        private void buttonCreateEx_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingExcavator = new DrawingExcavator(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            pictureBoxExcavator.Width, pictureBoxExcavator.Height);
            _drawingExcavator.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingExcavator.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingExcavator.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingExcavator.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingExcavator.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonStep_Click(object sender, EventArgs e)
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            if (comboBoxStrategy.Enabled)
            {
                _abstractStrategy = comboBoxStrategy.SelectedIndex
                switch
                {
                    0 => new MoveToCenter(),
                    1 => new MoveToBorder(),
                    _ => null,
                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new
                DrawingObjectExcavator(_drawingExcavator), pictureBoxExcavator.Width,
                pictureBoxExcavator.Height);
                comboBoxStrategy.Enabled = false;
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.Enabled = true;
                _abstractStrategy = null;
            }
        }
    }
}