﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator.MovementStrategy
{
    /// <summary>
    /// Стратегия перемещения объекта в правый нижний угол экрана
    /// </summary>
    public class MoveToBorder : AbstractStrategy
    {
        protected override bool IsTargetDestinaion()
        {
            var objParams = GetObjectParameters;
            if (objParams == null)
            {
                return false;
            }
            return objParams.ObjectBorderRight <= FieldWidth &&
            objParams.ObjectBorderRight + GetStep() >= FieldWidth &&
            objParams.ObjectBorderDown <= FieldHeight &&
            objParams.ObjectBorderDown + GetStep() >= FieldHeight;
        }
        protected override void MoveToTarget()
        {
            var objParams = GetObjectParameters;
            if (objParams == null)
            {
                return;
            }
            var diffX = objParams.ObjectBorderRight - FieldWidth;
            if (Math.Abs(diffX) > GetStep())
            {
                if (diffX > 0)
                {
                    MoveLeft();
                }
                else
                {
                    MoveRight();
                }

            }
            var diffY = objParams.ObjectBorderDown - FieldHeight;
            if (Math.Abs(diffY) > GetStep())
            {
                if (diffY > 0)
                {
                    MoveUp();
                }
                else
                {
                    MoveDown();
                }
            }
        }
    }
}
